/*
 * Upbit Open API
 * ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: ujhin942@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.18
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.UpbitOpenApi) {
      root.UpbitOpenApi = {};
    }
    root.UpbitOpenApi.Ask = factory(root.UpbitOpenApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';

  /**
   * The Ask model module.
   * @module model/Ask
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>Ask</code>.
   * 매도 시 제약사항
   * @alias module:model/Ask
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>Ask</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ask} obj Optional instance to populate.
   * @return {module:model/Ask} The populated <code>Ask</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('currency'))
        obj.currency = ApiClient.convertToType(data['currency'], 'String');
      if (data.hasOwnProperty('price_unit'))
        obj.priceUnit = ApiClient.convertToType(data['price_unit'], 'String');
      if (data.hasOwnProperty('min_total'))
        obj.minTotal = ApiClient.convertToType(data['min_total'], 'Number');
    }
    return obj;
  }

  /**
   * 화폐를 의미하는 영문 대문자 코드
   * @member {String} currency
   */
  exports.prototype.currency = undefined;

  /**
   * 주문금액 단위
   * @member {String} priceUnit
   */
  exports.prototype.priceUnit = undefined;

  /**
   * 최소 매도/매수 금액
   * @member {Number} minTotal
   */
  exports.prototype.minTotal = undefined;


  return exports;

}));
