# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' MarketInfo Class
#'
#' @field market 
#' @field korean_name 
#' @field english_name 
#' @field market_warning 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
MarketInfo <- R6::R6Class(
  'MarketInfo',
  public = list(
    `market` = NULL,
    `korean_name` = NULL,
    `english_name` = NULL,
    `market_warning` = NULL,
    initialize = function(`market`, `korean_name`, `english_name`, `market_warning`){
      if (!missing(`market`)) {
        stopifnot(is.character(`market`), length(`market`) == 1)
        self$`market` <- `market`
      }
      if (!missing(`korean_name`)) {
        stopifnot(is.character(`korean_name`), length(`korean_name`) == 1)
        self$`korean_name` <- `korean_name`
      }
      if (!missing(`english_name`)) {
        stopifnot(is.character(`english_name`), length(`english_name`) == 1)
        self$`english_name` <- `english_name`
      }
      if (!missing(`market_warning`)) {
        stopifnot(is.character(`market_warning`), length(`market_warning`) == 1)
        self$`market_warning` <- `market_warning`
      }
    },
    toJSON = function() {
      MarketInfoObject <- list()
      if (!is.null(self$`market`)) {
        MarketInfoObject[['market']] <- self$`market`
      }
      if (!is.null(self$`korean_name`)) {
        MarketInfoObject[['korean_name']] <- self$`korean_name`
      }
      if (!is.null(self$`english_name`)) {
        MarketInfoObject[['english_name']] <- self$`english_name`
      }
      if (!is.null(self$`market_warning`)) {
        MarketInfoObject[['market_warning']] <- self$`market_warning`
      }

      MarketInfoObject
    },
    fromJSON = function(MarketInfoJson) {
      MarketInfoObject <- jsonlite::fromJSON(MarketInfoJson)
      if (!is.null(MarketInfoObject$`market`)) {
        self$`market` <- MarketInfoObject$`market`
      }
      if (!is.null(MarketInfoObject$`korean_name`)) {
        self$`korean_name` <- MarketInfoObject$`korean_name`
      }
      if (!is.null(MarketInfoObject$`english_name`)) {
        self$`english_name` <- MarketInfoObject$`english_name`
      }
      if (!is.null(MarketInfoObject$`market_warning`)) {
        self$`market_warning` <- MarketInfoObject$`market_warning`
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "market": %s,
           "korean_name": %s,
           "english_name": %s,
           "market_warning": %s
        }',
        self$`market`,
        self$`korean_name`,
        self$`english_name`,
        self$`market_warning`
      )
    },
    fromJSONString = function(MarketInfoJson) {
      MarketInfoObject <- jsonlite::fromJSON(MarketInfoJson)
      self$`market` <- MarketInfoObject$`market`
      self$`korean_name` <- MarketInfoObject$`korean_name`
      self$`english_name` <- MarketInfoObject$`english_name`
      self$`market_warning` <- MarketInfoObject$`market_warning`
    }
  )
)
